diff --git a/Makefile b/Makefile
index 3085609..60e551f 100644
--- a/Makefile
+++ b/Makefile
@@ -169,19 +169,19 @@ endif
 # ARM64
 ifeq ($(ARCH), arm64)
 	DEFINES		+= -DCONFIG_ARM64
-	OBJS		+= arm/fdt.o
-	OBJS		+= arm/gic.o
-	OBJS		+= arm/gicv2m.o
-	OBJS		+= arm/ioport.o
-	OBJS		+= arm/kvm.o
-	OBJS		+= arm/kvm-cpu.o
-	OBJS		+= arm/pci.o
-	OBJS		+= arm/timer.o
+	OBJS		+= arm64/fdt.o
+	OBJS		+= arm64/gic.o
+	OBJS		+= arm64/gicv2m.o
+	OBJS		+= arm64/ioport.o
+	OBJS		+= arm64/kvm.o
+	OBJS		+= arm64/kvm-cpu.o
+	OBJS		+= arm64/pci.o
+	OBJS		+= arm64/timer.o
 	OBJS		+= hw/serial.o
-	OBJS		+= arm/arm-cpu.o
-	OBJS		+= arm/pvtime.o
-	OBJS		+= arm/pmu.o
-	ARCH_INCLUDE	:= arm/include
+	OBJS		+= arm64/arm-cpu.o
+	OBJS		+= arm64/pvtime.o
+	OBJS		+= arm64/pmu.o
+	ARCH_INCLUDE	:= arm64/include
 
 	ARCH_WANT_LIBFDT := y
 	ARCH_HAS_FLASH_MEM := y
diff --git a/arm/arm-cpu.c b/arm64/arm-cpu.c
similarity index 100%
rename from arm/arm-cpu.c
rename to arm64/arm-cpu.c
diff --git a/arm/fdt.c b/arm64/fdt.c
similarity index 100%
rename from arm/fdt.c
rename to arm64/fdt.c
diff --git a/arm/gic.c b/arm64/gic.c
similarity index 100%
rename from arm/gic.c
rename to arm64/gic.c
diff --git a/arm/gicv2m.c b/arm64/gicv2m.c
similarity index 100%
rename from arm/gicv2m.c
rename to arm64/gicv2m.c
diff --git a/arm/include/arm-common/gic.h b/arm64/include/arm-common/gic.h
similarity index 100%
rename from arm/include/arm-common/gic.h
rename to arm64/include/arm-common/gic.h
diff --git a/arm/include/arm-common/pci.h b/arm64/include/arm-common/pci.h
similarity index 100%
rename from arm/include/arm-common/pci.h
rename to arm64/include/arm-common/pci.h
diff --git a/arm/include/arm-common/timer.h b/arm64/include/arm-common/timer.h
similarity index 100%
rename from arm/include/arm-common/timer.h
rename to arm64/include/arm-common/timer.h
diff --git a/arm/include/asm/image.h b/arm64/include/asm/image.h
similarity index 100%
rename from arm/include/asm/image.h
rename to arm64/include/asm/image.h
diff --git a/arm/include/asm/kernel.h b/arm64/include/asm/kernel.h
similarity index 100%
rename from arm/include/asm/kernel.h
rename to arm64/include/asm/kernel.h
diff --git a/arm/include/asm/kvm.h b/arm64/include/asm/kvm.h
similarity index 100%
rename from arm/include/asm/kvm.h
rename to arm64/include/asm/kvm.h
diff --git a/arm/include/asm/pmu.h b/arm64/include/asm/pmu.h
similarity index 100%
rename from arm/include/asm/pmu.h
rename to arm64/include/asm/pmu.h
diff --git a/arm/include/asm/sve_context.h b/arm64/include/asm/sve_context.h
similarity index 100%
rename from arm/include/asm/sve_context.h
rename to arm64/include/asm/sve_context.h
diff --git a/arm/include/kvm/barrier.h b/arm64/include/kvm/barrier.h
similarity index 100%
rename from arm/include/kvm/barrier.h
rename to arm64/include/kvm/barrier.h
diff --git a/arm/include/kvm/fdt-arch.h b/arm64/include/kvm/fdt-arch.h
similarity index 100%
rename from arm/include/kvm/fdt-arch.h
rename to arm64/include/kvm/fdt-arch.h
diff --git a/arm/include/kvm/kvm-arch.h b/arm64/include/kvm/kvm-arch.h
similarity index 100%
rename from arm/include/kvm/kvm-arch.h
rename to arm64/include/kvm/kvm-arch.h
diff --git a/arm/include/kvm/kvm-config-arch.h b/arm64/include/kvm/kvm-config-arch.h
similarity index 100%
rename from arm/include/kvm/kvm-config-arch.h
rename to arm64/include/kvm/kvm-config-arch.h
diff --git a/arm/include/kvm/kvm-cpu-arch.h b/arm64/include/kvm/kvm-cpu-arch.h
similarity index 100%
rename from arm/include/kvm/kvm-cpu-arch.h
rename to arm64/include/kvm/kvm-cpu-arch.h
diff --git a/arm/ioport.c b/arm64/ioport.c
similarity index 100%
rename from arm/ioport.c
rename to arm64/ioport.c
diff --git a/arm/kvm-cpu.c b/arm64/kvm-cpu.c
similarity index 100%
rename from arm/kvm-cpu.c
rename to arm64/kvm-cpu.c
diff --git a/arm/kvm.c b/arm64/kvm.c
similarity index 100%
rename from arm/kvm.c
rename to arm64/kvm.c
diff --git a/arm/pci.c b/arm64/pci.c
similarity index 100%
rename from arm/pci.c
rename to arm64/pci.c
diff --git a/arm/pmu.c b/arm64/pmu.c
similarity index 100%
rename from arm/pmu.c
rename to arm64/pmu.c
diff --git a/arm/pvtime.c b/arm64/pvtime.c
similarity index 100%
rename from arm/pvtime.c
rename to arm64/pvtime.c
diff --git a/arm/timer.c b/arm64/timer.c
similarity index 100%
rename from arm/timer.c
rename to arm64/timer.c